From 8811554fcb400d1291fed83d956f1a906d60de0c Mon Sep 17 00:00:00 2001
From: Rohit Yadav <rohityadav89@gmail.com>
Date: Mon, 27 Dec 2010 04:37:15 +0530
Subject: [PATCH 1/5] LibVLC-jni: Also enable to use ARMv7, put all jni related stuff in one script.
 Move jni to vlc-android, keep in one place. Fix hardcoded argc count.

---
 extras/package/android/compileLibvlcjni.sh         |   17 -----
 extras/package/android/configure_libvlcjni.sh      |   69 ------------------
 .../package/android/libvlcjni/jni/Application.mk   |    1 -
 extras/package/android/libvlcjni/jni/libvlcjni.c   |   76 -------------------
 extras/package/android/make_libvlcjni.sh           |   17 +++++
 .../package/android/vlc-android/jni/Application.mk |    3 +
 extras/package/android/vlc-android/jni/libvlcjni.c |   77 ++++++++++++++++++++
 7 files changed, 97 insertions(+), 163 deletions(-)
 delete mode 100755 extras/package/android/compileLibvlcjni.sh
 delete mode 100755 extras/package/android/configure_libvlcjni.sh
 delete mode 100644 extras/package/android/libvlcjni/jni/Application.mk
 delete mode 100644 extras/package/android/libvlcjni/jni/libvlcjni.c
 create mode 100755 extras/package/android/make_libvlcjni.sh
 create mode 100644 extras/package/android/vlc-android/jni/Application.mk
 create mode 100644 extras/package/android/vlc-android/jni/libvlcjni.c

diff --git a/extras/package/android/compileLibvlcjni.sh b/extras/package/android/compileLibvlcjni.sh
deleted file mode 100755
index db99353..0000000
--- a/extras/package/android/compileLibvlcjni.sh
+++ /dev/null
@@ -1,17 +0,0 @@
-#!/bin/sh
-
-if [ -z "$ANDROID_NDK" ]; then
-    echo "Set your ANDROID_NDK environment variable"
-    exit 1
-fi
-
-
-cd libvlcjni
-$ANDROID_NDK/ndk-build
-
-if [  ! -d "../vlc-android/libs/armeabi" ]; then
-    mkdir -p ../vlc-android/libs/armeabi/
-fi
-
-cp -v libs/armeabi/libvlcjni.so ../vlc-android/libs/armeabi/
-
diff --git a/extras/package/android/configure_libvlcjni.sh b/extras/package/android/configure_libvlcjni.sh
deleted file mode 100755
index 5f42584..0000000
--- a/extras/package/android/configure_libvlcjni.sh
+++ /dev/null
@@ -1,69 +0,0 @@
-#!/bin/sh
-
-# Get the VLC build path
-if [ "x$1" = "x" ]; then
-    echo "This script needs the vlc build path"
-    exit 1
-fi
-VLC_BULD_PATH=$1
-
-# Get the VLC contrib build directory
-if [ "x$2" = "x" ]; then
-    echo "This script needs the contrib build path"
-    exit 1
-fi
-VLC_CONTRIB_PATH=$2
-
-if [ -z "$ANDROID_NDK" ]; then
-    echo "Please define your ANDROID_NDK environment variable"
-    exit 1
-fi
-
-# Do we have an absolute path ?
-prefix=""
-if [ `echo $VLC_BULD_PATH | head -c 1` != "/" ]; then
-    prefix="../"
-fi
-
-# If the contrib path is not absolute, change it
-if [ `echo $VLC_CONTRIB_PATH | head -c 1` != "/" ]; then
-    VLC_CONTRIB_PATH="../$VLC_CONTRIB_PATH"
-fi
-
-# Lookup for every static modules in the VLC build path
-modules=`find $VLC_BULD_PATH/modules -name '*.a'|grep -v dvdnav|grep -v mmap|grep -v spatializer`
-
-# Build the list of modules
-LDFLAGS=""
-DEFINITION=""
-BUILTINS="const void *vlc_builtins_modules[] = {\n"
-
-for file in $modules; do
-    name=`echo $file | sed 's/.*\.libs\/lib//' | sed 's/_plugin\.a//'`
-
-    LDFLAGS=$LDFLAGS"$prefix$file "
-    DEFINITION=$DEFINITION"vlc_declare_plugin(${name});\n"
-    BUILTINS=$BUILTINS"    vlc_plugin(${name}),\n"
-done;
-
-BUILTINS=$BUILTINS"    NULL\n"
-BUILTINS=$BUILTINS"};\n"
-
-# Write the right files
-rm -f libvlcjni/jni/libvlcjni.h
-echo "// libvlcjni.h\n// Autogenerated from the list of modules\n" > libvlcjni/jni/libvlcjni.h
-echo "$DEFINITION\n" >> libvlcjni/jni/libvlcjni.h
-echo $BUILTINS >> libvlcjni/jni/libvlcjni.h
-
-rm -f libvlcjni/jni/Android.mk
-echo "LOCAL_PATH := \$(call my-dir)
-
-include \$(CLEAR_VARS)
-
-LOCAL_MODULE    := libvlcjni
-LOCAL_SRC_FILES := libvlcjni.c
-LOCAL_C_INCLUDES := \$(LOCAL_PATH)/../../../../../include
-LOCAL_LDLIBS := -L$ANDROID_NDK/platforms/android-9/arch-arm/usr/lib -L$VLC_CONTRIB_PATH/lib $LDFLAGS $prefix$VLC_BULD_PATH/src/.libs/libvlc.a $prefix$VLC_BULD_PATH/src/.libs/libvlccore.a -ldl -lz -lm -logg -lvorbisenc -lvorbis -lFLAC -lspeex -ltheora -lavformat -lavcodec -lavcore -lavutil -lpostproc -lswscale -lmpeg2 -lgcc -lpng -logg -ldca -ldvbpsi -ltwolame -lkate -lOpenSLES -lGLESv1_CM -lEGL -landroid
-
-include \$(BUILD_SHARED_LIBRARY)
-" > libvlcjni/jni/Android.mk
diff --git a/extras/package/android/libvlcjni/jni/Application.mk b/extras/package/android/libvlcjni/jni/Application.mk
deleted file mode 100644
index 22d188e..0000000
--- a/extras/package/android/libvlcjni/jni/Application.mk
+++ /dev/null
@@ -1 +0,0 @@
-APP_PLATFORM := android-9
diff --git a/extras/package/android/libvlcjni/jni/libvlcjni.c b/extras/package/android/libvlcjni/jni/libvlcjni.c
deleted file mode 100644
index 4dc09d6..0000000
--- a/extras/package/android/libvlcjni/jni/libvlcjni.c
+++ /dev/null
@@ -1,76 +0,0 @@
-#include <stdio.h>
-#include <string.h>
-
-#include <android/native_window_jni.h>
-
-#include <jni.h>
-
-#include <vlc/vlc.h>
-
-#include "libvlcjni.h"
-
-// Native android window to display the video.
-ANativeWindow *p_nativeWindow;
-
-
-void Java_vlc_android_LibVLC_setSurface(JNIEnv *env, jobject thiz, jobject surface)
-{
-    p_nativeWindow = ANativeWindow_fromSurface(env, surface);
-}
-
-jint Java_vlc_android_LibVLC_init(JNIEnv *env, jobject thiz)
-{
-    char psz_pWin[255];
-    snprintf(psz_pWin, 255, "%i", p_nativeWindow);
-
-    const char *argv[] = {"-I", "dummy", "-vvv", "--no-plugins-cache",
-                          "--no-audio", "--no-drop-late-frames",
-                          "--vout", "egl_android",
-                          "--egl-android-window", psz_pWin};
-    return (jint)libvlc_new_with_builtins(10, argv, vlc_builtins_modules);
-}
-
-void Java_vlc_android_LibVLC_destroy(JNIEnv *env, jobject thiz, jint instance)
-{
-    libvlc_instance_t *p_instance = (libvlc_instance_t*)instance;
-    libvlc_release(p_instance);
-}
-
-void Java_vlc_android_LibVLC_readMedia(JNIEnv *env, jobject thiz, jint instance,
-                                       jstring mrl)
-{
-    jboolean isCopy;
-    const char *psz_mrl = (*env)->GetStringUTFChars(env, mrl, &isCopy);
-
-    /* Create a new item */
-    libvlc_media_t *m = libvlc_media_new_path((libvlc_instance_t*)instance,
-                                              psz_mrl);
-
-    /* Create a media player playing environement */
-    libvlc_media_player_t *mp = libvlc_media_player_new_from_media(m);
-
-    /* No need to keep the media now */
-    libvlc_media_release(m);
-
-    /* Play the media. */
-    libvlc_media_player_play(mp);
-
-    //libvlc_media_player_release(mp);
-
-    (*env)->ReleaseStringUTFChars(env, mrl, psz_mrl);
-}
-
-jstring Java_vlc_android_LibVLC_version(JNIEnv* env, jobject thiz)
-{
-    return (*env)->NewStringUTF(env, libvlc_get_version());
-}
-
-jstring Java_vlc_android_LibVLC_compiler(JNIEnv* env, jobject thiz)
-{
-    return (*env)->NewStringUTF(env, libvlc_get_compiler());
-}
-
-jstring Java_vlc_android_LibVLC_changeset(JNIEnv* env, jobject thiz)
-{
-    return (*env)->NewStringUTF(env, libvlc_get_changeset());
-}
diff --git a/extras/package/android/make_libvlcjni.sh b/extras/package/android/make_libvlcjni.sh
new file mode 100755
index 0000000..db99353
--- /dev/null
+++ b/extras/package/android/make_libvlcjni.sh
@@ -0,0 +1,17 @@
+#!/bin/sh
+
+if [ -z "$ANDROID_NDK" ]; then
+    echo "Set your ANDROID_NDK environment variable"
+    exit 1
+fi
+
+
+cd libvlcjni
+$ANDROID_NDK/ndk-build
+
+if [  ! -d "../vlc-android/libs/armeabi" ]; then
+    mkdir -p ../vlc-android/libs/armeabi/
+fi
+
+cp -v libs/armeabi/libvlcjni.so ../vlc-android/libs/armeabi/
+
diff --git a/extras/package/android/vlc-android/jni/Application.mk b/extras/package/android/vlc-android/jni/Application.mk
new file mode 100644
index 0000000..23fa139
--- /dev/null
+++ b/extras/package/android/vlc-android/jni/Application.mk
@@ -0,0 +1,3 @@
+# The ARMv7 is significanly faster due to the use of the hardware FPU
+APP_ABI := armeabi armeabi-v7a
+APP_PLATFORM := android-9
diff --git a/extras/package/android/vlc-android/jni/libvlcjni.c b/extras/package/android/vlc-android/jni/libvlcjni.c
new file mode 100644
index 0000000..e80a577
--- /dev/null
+++ b/extras/package/android/vlc-android/jni/libvlcjni.c
@@ -0,0 +1,77 @@
+#include <stdio.h>
+#include <string.h>
+
+#include <android/native_window_jni.h>
+
+#include <jni.h>
+
+#include <vlc/vlc.h>
+
+#include "libvlcjni.h"
+
+// Native android window to display the video.
+ANativeWindow *p_nativeWindow;
+
+
+void Java_vlc_android_LibVLC_setSurface(JNIEnv *env, jobject thiz, jobject surface)
+{
+    p_nativeWindow = ANativeWindow_fromSurface(env, surface);
+}
+
+jint Java_vlc_android_LibVLC_init(JNIEnv *env, jobject thiz)
+{
+    char psz_pWin[255];
+    snprintf(psz_pWin, 255, "%i", p_nativeWindow);
+
+    const char *argv[] = {"-I", "dummy", "-vvv", "--no-plugins-cache",
+                          "--no-audio", "--no-drop-late-frames",
+                          "--vout", "egl_android",
+                          "--egl-android-window", psz_pWin};
+    int argc = sizeof(argv) / sizeof(*argv);
+    return (jint)libvlc_new_with_builtins(argc, argv, vlc_builtins_modules);
+}
+
+void Java_vlc_android_LibVLC_destroy(JNIEnv *env, jobject thiz, jint instance)
+{
+    libvlc_instance_t *p_instance = (libvlc_instance_t*)instance;
+    libvlc_release(p_instance);
+}
+
+void Java_vlc_android_LibVLC_readMedia(JNIEnv *env, jobject thiz, jint instance,
+                                       jstring mrl)
+{
+    jboolean isCopy;
+    const char *psz_mrl = (*env)->GetStringUTFChars(env, mrl, &isCopy);
+
+    /* Create a new item */
+    libvlc_media_t *m = libvlc_media_new_path((libvlc_instance_t*)instance,
+                                              psz_mrl);
+
+    /* Create a media player playing environement */
+    libvlc_media_player_t *mp = libvlc_media_player_new_from_media(m);
+
+    /* No need to keep the media now */
+    libvlc_media_release(m);
+
+    /* Play the media. */
+    libvlc_media_player_play(mp);
+
+    //libvlc_media_player_release(mp);
+
+    (*env)->ReleaseStringUTFChars(env, mrl, psz_mrl);
+}
+
+jstring Java_vlc_android_LibVLC_version(JNIEnv* env, jobject thiz)
+{
+    return (*env)->NewStringUTF(env, libvlc_get_version());
+}
+
+jstring Java_vlc_android_LibVLC_compiler(JNIEnv* env, jobject thiz)
+{
+    return (*env)->NewStringUTF(env, libvlc_get_compiler());
+}
+
+jstring Java_vlc_android_LibVLC_changeset(JNIEnv* env, jobject thiz)
+{
+    return (*env)->NewStringUTF(env, libvlc_get_changeset());
+}
-- 
1.7.1

